///////////////////////////////////////////////////////
//	de_la_exp1 - HEADER
///////////////////////////////////////////////////////

#pragma once

extern "C"
{

#include <windows.h>
#include <stdio.h>

#include "structs.h"

#include "BitOperations.h"
#include "llist_ChanInfo.h"
#include "llist_data.h"






///////////////////////////////////
// gl. Variablen
///////////////////////////////////

	LL_DataNode			*DataList = NULL;
	LL_DataNode			*DataTempList = NULL;



	LL_ChanInfoNode		*ChanList = NULL;

	LL_DataNode			*DataMultiList = NULL;

	LA_HWInfo				gl_HWInfo;
	unsigned char		*gl_buffer=NULL;



///////////////////////////////////
//Funktionen / Schnittstellen
///////////////////////////////////

	exC dllExp ULONG LA_EXP_setInterpreter(ULONG channelNo, ULONG nInterpreter, ULONG parCount);
	
		// Logi+ liefert den ausgewhlten Interpreter fr channelNo
		//channelNo = belegter Kanal
		//nInterpreter = Kanal-Nr.
		//parCount =  Anzahl der Parameter fr diesen Interpreter


	exC dllExp ULONG LA_EXP_setConfiguration(ULONG channelNo, ULONG parNo, 
											 ULONG nChannel, ULONG nSelection) ;

		// Logi+ liefert die ausgewhlten Parameter fr Kanal channelNo und Parameter parCount
		//*name = Name des ausgewhlten Kanals	
		//name_length = Lnge des Kanalnamens
		//*auswahl = Auswahltext (z.B. Steigende Flanke)
		//auswahl_length = Lnge des Auswahltextes


					   
//	exC dllExp	ULONG la_exp_convert_data(ULONG todo,  ULONG nNumData, unsigned char *la_buffer, LA_HWInfo HWInfo, 
//						sData *pData);

	exC dllExp	void  LA_EXP_startNew();

	exC dllExp	ULONG la_exp_convert_data(ULONG todo, ULONG nNumData,  unsigned char *pData, 
		LA_HWInfo HWInfo, LA_Configuration LAConf, unsigned char *la_buffer, unsigned long t1, unsigned long t2);


	exC dllExp ULONG la_exp_get_data(ULONG todo, ULONG nNumData, unsigned char *cData,
									unsigned long t1, unsigned long t2);

	exC dllExp ULONG la_exp_get_multi_data(LA_HWInfo HWInfo, unsigned char *la_buffer, 
									int nTodo, int nChannel, ULONG t1, ULONG t2, 
									int nChanBegin, int nChanEnd, unsigned char* cData);


	exC dllExp ULONG la_exp_interprete_data(LA_HWInfo HWInfo, LA_Configuration LAConf, 
									unsigned char *la_buffer, unsigned int todo);

	exC dllExp	ULONG LA_EXP_GetDLLVersion();
	exC	dllExp char *LA_EXP_GetDLLDate();

	exC dllExp	ULONG LA_EXP_GetInterpreterNames(ULONG todo, char *text, ULONG text_length);

	exC dllExp	ULONG LA_EXP_GetConfigurationInfo(ULONG InterpreterNr, ULONG todo, char * name, 
											 ULONG name_length, char * auswahl, ULONG auswahl_length);
	
	exC bool APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved);

//weitere Funktionen (fr die Interne Verarbeitung
/*
	dllExp bool IsSet(const LA_HWInfo HWInfo,unsigned char *buf, 
				ULONG nChannel, ULONG nSample);

	dllExp bool SetBit(const LA_HWInfo HWInfo,unsigned char *buf, 
				ULONG nChannel, ULONG nSample, bool bit);
*/

/*
	int ConvertSpi(LA_HWInfo HWInfo, int nChannel, SPIConfig SpiCfg, unsigned char *cBuffer,
					unsigned long t1, unsigned long t2);
*/

/*
	int ConvertRS232(LA_HWInfo HWInfo,LA_Configuration LAConf, int nChannel, 
				 RS232Config RsCfg, unsigned char *cBuffer,
				 unsigned long t1, unsigned long t2);
*/
/*
	int ConvertCAN2(LA_HWInfo HWInfo,LA_Configuration LAConf, int nChannel, 
				 CANConfig CanCfg, unsigned char *cBuffer,
				 unsigned long t1, unsigned long t2);
*/

	unsigned long potentiate(unsigned int nBase, unsigned int nExp);

	char CalcByte(unsigned long nVal, unsigned int nNum);
	void TestLinkedLists();

}
